﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace WindowsApplication11
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();

			comboBox1.DisplayMember = "EnumDisplayText";
			comboBox1.ValueMember = "EnumValue";
			comboBox1.DataSource = EnumDescription.GetTexts(typeof(MyEnum), EnumDescription.SortType.Rank);

			comboBox2.DisplayMember = "EnumDisplayText";
			comboBox2.ValueMember = "EnumValue";
			comboBox2.DataSource = EnumDescription.GetTexts(
				typeof(MyEnum2),
				EnumDescription.SortType.Value);
		}

		private void button1_Click( object sender, EventArgs e )
		{
			MyEnum selectValue = (MyEnum)comboBox1.SelectedValue;

			MessageBox.Show(
				EnumDescription.GetText(typeof(MyEnum), (int)selectValue));

			string result = string.Empty;
			foreach ( EnumDescription var in EnumDescription.GetTexts(typeof(MyEnum2), EnumDescription.SortType.Rank) )
			{
				result += Environment.NewLine + string.Format("枚举定义：{0}\t数字值：{1}\t描述文本：{2}",
					((MyEnum2)var.EnumValue).ToString(), var.EnumValue, var.EnumDisplayText);
			}

			MessageBox.Show(result);



			MessageBox.Show(
				EnumDescription.GetText(typeof(WorkState), (int)WorkState.Planing));
		}
	}


	[EnumDescription(MyEnum.One, "数字一")]
	[EnumDescription(MyEnum.Two, "数字二")]
	[EnumDescription(MyEnum.Three, "数字三")]
	[EnumDescription(MyEnum.Four, "数字四")]
	[EnumDescription(MyEnum.Five, "数字五")]
	[EnumDescription(MyEnum.Six, "数字六")]
	[EnumDescription(MyEnum.Seven, "数字七")]
	[EnumDescription(MyEnum.Eight, "数字八")]
	[EnumDescription(MyEnum.Nine, "数字九")]
	[EnumDescription(MyEnum.Ten, "数字十")]
	enum MyEnum
	{
		One = 1, Two, Three, Four, Five, Six, Seven, Eight, Nine, Ten
	}


	[EnumDescription(MyEnum2.You, "你", 1)]
	[EnumDescription(MyEnum2.I, "我", 2)]
	[EnumDescription(MyEnum2.He, "他", 3)]
	[EnumDescription(MyEnum2.She, "她", 4)]
	enum MyEnum2
	{
		You = 1, I = 2, He = 4, She = 8
	}


	[EnumDescription(WorkState.Planing, "计划制定中")]
	[EnumDescription(WorkState.Ready, "一切就绪")]
	[EnumDescription(WorkState.Processing, "工作进行中")]
	[EnumDescription(WorkState.Finished, "完成工作")]
	enum WorkState
	{ 
		Planing,
		Ready,
		Processing,
		Finished
	}
}